﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Text.RegularExpressions;

namespace RoboRace
{
    public partial class Form1 : Form
    {
        string obsahServeru = "";

        public static string[,] pole = new string[20, 20];
        Point hrac = new Point(0, 0);
        PointF hracStin = new PointF(0, 0);
        string smer = "";
        int id = 0;

        public Form1()
        {
            InitializeComponent();
        }

        private void timerDrawing_Tick(object sender, EventArgs e)
        {
            // vytvoření kreslícího plátna
            Bitmap bmp = new Bitmap(plocha.Width, plocha.Height);
            Graphics g = Graphics.FromImage(bmp);


            
            
            // vykresli polí
            for (int x = 0; x < 20; x++)
            {
                for (int y = 0; y < 20; y++)
                {

                    if (pole[x, y] == ".") // vykreslení cesty
                        g.FillRectangle(Brushes.White, x * 20, y * 20,
                            20, 20);
                    if (pole[x, y] == "X") // zdi
                        g.FillRectangle(Brushes.Red, x * 20, y * 20,
                            20, 20);
                    if (pole[x, y] == "$") // cíle
                        g.FillRectangle(Brushes.Green, x * 20, y * 20,
                            20, 20);

                    if (hracStin != new Point(0, 0)) // vykreslije AI
                    {
                        g.FillRectangle(Brushes.Khaki, (hracStin.X - 1) * 20, (hracStin.Y - 1) * 20,
                            20, 20);
                    }
                    if (hrac != new Point(0, 0)) // hrac
                    {
                        g.FillRectangle(Brushes.Yellow, (hrac.X - 1) * 20, (hrac.Y - 1) * 20,
                            20, 20);
                        g.DrawString(smer, new Font("Courier New", 8),
                            Brushes.Black, (hrac.X - 1) * 20, (hrac.Y - 1) * 20);
                    }

                    
                    
                    {
                        g.DrawString(pole[x, y], new Font("Courier New", 8),
                            Brushes.Black, x * 20, y * 20);
                    }
                }
            }

            for (int i = 0; i < cesty.Count; i++) // volání AI
            {
                cesty[i].Akce();
                g.FillRectangle(Brushes.Blue, cesty[i].souradnice.X * 20,
                    cesty[i].souradnice.Y * 20, 20, 20);
                btnStartAI.Text = cesty[i].souradnice.ToString();
                Application.DoEvents();
            }


            // vykreslení mříže
            for (int x = 1; x < 20; x++)
            {
                g.DrawLine(Pens.Black, x * 20, 0, x * 20, plocha.Height);
            }
            for (int y = 1; y < 20; y++)
            {
                g.DrawLine(Pens.Black, 0, y * 20, plocha.Width, y * 20);
            }

            plocha.Image = bmp;
        }

        private void btnNewGame_Click(object sender, EventArgs e)
        {
            DotazNaServer("http://localhost:8000/start");
        }

        private void DotazNaServer(string adresa)
        {
            obsahServeru = "";
            // Navázání spojení a následné stáhnutí a přečtění odpovědi od serveru
            WebClient webClient = new WebClient();
            webClient.DownloadFile(adresa,
                "Temp.txt");
            StreamReader sr = new StreamReader("Temp.txt");
            obsahServeru = sr.ReadToEnd();
            sr.Close();
            textBox1.Text = obsahServeru;

            // zadání plochy 20x20
            string[] radky = Regex.Split(obsahServeru, "\r\n");
            if (radky.Length < 20)
                MessageBox.Show(obsahServeru); // pokud odpověď od serveru není mapa
            else
            {
                //Přiřazení ID
                id = int.Parse(radky[0]);
                labID.Text = "ID: " + id.ToString();

                // Zadání hodnot v mapě do dvojrozměrného pole
                for (int i = 1; i < 21; i++)
                {
                    string[] pismena = Regex.Split(radky[i], "");
                    int x = 0;

                    for (int y = 0; y < pismena.Length; y++)
                    {
                        if (pismena[y] != "")
                            pole[x++, i - 1] = pismena[y];
                    }
                }
                // zadání pozice hráče
                string[] souradnice = Regex.Split(radky[21], " ");
                hrac = new Point(int.Parse(souradnice[0]), int.Parse(souradnice[1]));
                hracStin = hrac;
                smer = souradnice[2];
                // výpis
                labSmer.Text = "Směr: " + (smer == "R" ? "Doprava" :
                    smer == "L" ? "Doleva" :
                    smer == "N" ? "Nahoru" :
                    smer == "D" ? "Dolu" : "Není");

                // zadání možných tahů
                string[] tahy = Regex.Split(radky[22], "");
                string vs = "";
                for (int i = 0; i < tahy.Length; i++)
                {
                    if (tahy[i] != "")
                        vs += tahy[i];
                }
                labTahy.Text = "Možné tahy: " + vs;
                txtTahy.Text = "";
            }
        }

        private void btnNext_Click(object sender, EventArgs e)
        {
            if (txtTahy.TextLength != 5) // pokud tahů není 5
            {
                MessageBox.Show("Zadejte 5 tahů\r\nUpravte zadání...",
                    "Nevalidní tahy", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
            else // když je tahů 5, odešle se dotaz na server s novými tahy
            {
                DotazNaServer("http://localhost:8000/kolo?id="
                    +id+"&pohyby="+txtTahy.Text);
            }
            
        }

        void Tah(bool kam) // otočení hráče
        {
            if (kam) // doprava
            {
                if (smer == "N")
                    smer = "R";
                else if (smer == "R")
                    smer = "D";
                else if (smer == "D")
                    smer = "L";
                else if (smer == "L")
                    smer = "N";
            }
            else // doleva
            {
                if (smer == "N")
                    smer = "L";
                else if (smer == "R")
                    smer = "N";
                else if (smer == "D")
                    smer = "R";
                else if (smer == "L")
                    smer = "D";
            }
        }

        private void txtTahy_TextChanged(object sender, EventArgs e)
        {
            // Zobrazení možných tahů už při psaní tahů

            /*
            if (txtTahy.Text != "")
            {
                string[] tahy = Regex.Split(txtTahy.Text, "");
                for (int i = 0; i < tahy.Length; i++)
                {
                    if (tahy[i] != "")
                    {
                        if (tahy[i] == "R")
                            Tah(true);
                        else if (tahy[i] == "L")
                            Tah(false);
                        
                        if (tahy[i] == "1"
                            || tahy[i] == "2"
                            || tahy[i] == "3")
                        {
                            if (smer == "R")
                                hracStin.X += int.Parse(tahy[i]);
                            if(smer == "D")
                                hracStin.Y += int.Parse(tahy[i]);
                            if (smer == "N")
                                hracStin.Y -= int.Parse(tahy[i]);
                            if (smer == "L")
                                hracStin.X -= int.Parse(tahy[i]);

                        }
                    }
                        
                }
             
            }
             */
        }

        public static List<AI> cesty = new List<AI>();

        private void btnStartAI_Click(object sender, EventArgs e)
        {
            // vytvoření AI
            cesty.Add(new AI(new Point(hrac.X-1, hrac.Y-1), 0));
        }
    }
}
